#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include  <Adafruit_SSD1306.h>
#include <Fonts/FreeSans9pt7b.h>
#include <Fonts/FreeMonoOblique9pt7b.h>
#include  <DHT.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define  SCREEN_HEIGHT 64 // OLED display height, in pixels

#define OLED_RESET     4  // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH,  SCREEN_HEIGHT, &Wire, OLED_RESET);

#define sensor    A0 
#define DHTPIN  2          // Digital pin 2
#define DHTTYPE DHT11     // DHT 11

int gasLevel  = 0;         //int variable for gas level
String quality =""; 
DHT dht(DHTPIN,  DHTTYPE);



void sendSensor()
{
  float h = dht.readHumidity();
  float t = dht.readTemperature();

  if (isnan(h) || isnan(t)) {
  Serial.println("Failed  to read from DHT sensor!");
    return;
  }
  display.setTextColor(WHITE);
  display.setTextSize(1);
  display.setFont();
  display.setCursor(0, 43);
  display.println("Temp  :");
  display.setCursor(80, 43);
  display.println(t);
  display.setCursor(114, 43);
  display.println("C");
  display.setCursor(0,  56);
  display.println("RH    :");
  display.setCursor(80, 56);
  display.println(h);
  display.setCursor(114, 56);
  display.println("%");
}

const int GOOD_THRESHOLD = 181;
const int POOR_THRESHOLD_LOW = 182;
const int POOR_THRESHOLD_HIGH = 225;
const int VERY_BAD_THRESHOLD_LOW = 226;
const int VERY_BAD_THRESHOLD_HIGH = 300;
const int TOXIC_THRESHOLD_LOW = 301;
const int TOXIC_THRESHOLD_HIGH = 350;

void air_sensor()
{
  int sensorReading = analogRead(sensor);
  String airQuality;

  if (sensorReading < GOOD_THRESHOLD) {
    airQuality = "GOOD!";
  } else if (sensorReading >= POOR_THRESHOLD_LOW && sensorReading <= POOR_THRESHOLD_HIGH) {
    airQuality = "Poor!";
  } else if (sensorReading >= VERY_BAD_THRESHOLD_LOW && sensorReading <= VERY_BAD_THRESHOLD_HIGH) {
    airQuality = "Very bad!";
  } else if (sensorReading >= TOXIC_THRESHOLD_LOW && sensorReading <= TOXIC_THRESHOLD_HIGH) {
    airQuality = "Dangerous!";
  } else {
    airQuality = "Normal!";
  }

  display.setTextColor(WHITE);
  display.setTextSize(1);
  display.setCursor(1, 5);
  display.setFont();
  display.println("Air Quality:");
  display.setTextSize(1);
  display.setCursor(20, 23);
  display.setFont(&FreeMonoOblique9pt7b);
  display.println(airQuality);
}


void setup() {
  Serial.begin(9600);
  pinMode(sensor,INPUT);
  dht.begin();
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3c)) { // Address  0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
}
  display.clearDisplay();
  display.setTextColor(WHITE);
  
  display.setTextSize(2);
  display.setCursor(50, 0);
  display.println("Air");
  display.setTextSize(2);
  display.setCursor(23, 20);
  display.println("Qulaity   Monitor");
  display.display();
  delay(2000);
  display.clearDisplay();
  
  display.setTextSize(2);
  display.setCursor(16, 20);
  display.println("BY PRINCE");
  display.display();
  delay(2000);
  display.clearDisplay();    
}

void loop() {
display.clearDisplay();
air_sensor();
sendSensor();
display.display();  
}
